#ifndef GL_CAMERA_H
#define GL_CAMERA_H

#include "point3.h"

class gl_camera
{
public:
    gl_camera() : distance(2.0), focal_point(point3(0.0, 0.0, 0.0)),
        elevation(0.0), twist(0.0)  {}

    gl_camera(
        const point3& focal_point, double distance, 
        double elevation, double twist
    ) : distance(distance), focal_point(focal_point), elevation(elevation), twist(twist) 
    {}

    void set_elevation(double deg);

    double get_elevation() const;
    void set_delta_elevation(double deg);

    void set_twist(double deg);
    void set_delta_twist(double delta_deg);
    double get_twist() const;
    
    void set_distance(double d);
    void set_delta_distance(double delta_d);
    double get_distance();

    void set_focal_point(const point3& focal_point);
    const point3& get_focal_point();

    void apply_gl_transform();

private:
    double distance;
    point3 focal_point;

    double elevation, twist;

}; // class gl_camera

#endif
