#ifndef POINT3_H
#define POINT3_H

#include <cassert>
#include <memory>

class point3
{
public:
    point3(double x, double y, double z)
    {
        this->set(x, y, z);
    }

    point3(double u[3])
    {
        memcpy(p, u, 3 * sizeof(double));
    }

    double& operator[](int index)
    {
        assert(index >= 0 && index < 3);

        return p[index];
    }

    const double& operator[](int index) const
    {
        assert(index >= 0 && index < 3);

        return p[index];
    }

    double get_x() const { return p[0]; }
    double get_y() const { return p[1]; }
    double get_z() const { return p[2]; }
    
    void set(double x, double y, double z) 
    { 
        p[0] = x; p[1] = y; p[2] = z;
    }


private:
    double p[3];

}; // class point3

#endif
